﻿using System;

[
    Tracker("CR-0001",
    "jakaś poprawka błędu",
    EngineerId = "Józef",
    ChangeDate = "4.07.2008")
]
class ReflectingOnAttributes
{
    static void Main(string[] args)
    {
        try 
        {
            Type classType = typeof(ReflectingOnAttributes);
            Type attributeType = typeof(TrackerAttribute);

            TrackerAttribute attrib = (TrackerAttribute) 
                Attribute.GetCustomAttribute(classType,
                                             attributeType);

            Console.WriteLine("Nr problemu:    {0}",
                attrib.ProblemId);
            Console.WriteLine("Identyfikator projektanta: {0}",
                attrib.EngineerId);
            Console.WriteLine("Data zmiany:  {0}",
                attrib.ChangeDate);
            Console.WriteLine("Opis:  {0}",
                attrib.FixDescription);
        }
        catch(Exception e) 
        {
            Console.WriteLine(
                "Ogólny wyjątek: {0}\nStan stosu:\n{1}",
                e.Message, e.StackTrace);
        }
    }
}
